<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>db_cachedb Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284027"></a>db_cachedb Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Vladut-Stefan</span> <span class="surname">Paiu</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Vladut-Stefan</span> <span class="surname">Paiu</span></h3></div></div></div><div><p class="copyright">Copyright © 2013 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id281458">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id271631">1.1. Overview</a></span></dt><dd><dl><dt><span class="section"><a href="#id284068">1.1.1.  The idea</a></span></dt><dt><span class="section"><a href="#id284086">1.1.2. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249069">1.1.3. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248023">1.2. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249570">1.2.1. 
                <code class="varname">cachedb_url</code> (str)
            </a></span></dt></dl></dd><dt><span class="section"><a href="#id249605">1.3. Examples of Usage</a></span></dt><dd><dl><dt><span class="section"><a href="#id249610">1.3.1. 
                <code class="varname">Distributed Subscriber Base</code>
            </a></span></dt></dl></dd><dt><span class="section"><a href="#id249650">1.4. Current Limitations</a></span></dt><dd><dl><dt><span class="section"><a href="#id249655">1.4.1. 
                <code class="varname">CacheDB modules integration</code>
            </a></span></dt><dt><span class="section"><a href="#id249671">1.4.2. 
                <code class="varname">Extensive Testing Needed</code>
            </a></span></dt><dt><span class="section"><a href="#id249688">1.4.3. 
                <code class="varname">CacheDB Specific 'schema' and other incompatibilities</code>
            </a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249582">Set
                    <code class="varname">cachedb_url</code> parameter
                </a></dt><dt>1.2. <a href="#id249624">OpenSIPS CFG Snippet for using DB_CACHEDB
                </a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id281458"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id271631"></a>1.1. Overview</h2></div><div><h2 class="title" style="clear: both"><a name="id271631"></a>1.1. Overview</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id284068"></a>1.1.1.  The idea</h3></div></div></div><p>
				The db_cachedb module will expose the same front db api, however it will run on top
				of a NoSQL back-end, emulating the SQL calls to the back-end specific queries.

				Thus, any OpenSIPS module that would regularily need a regular SQL-based database,
				will now be able to run over a NoSQL back-end, allowing for a much easier distribution
				and integration of the currently existing OpenSIPS modules in a distributed environment.
            </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id284086"></a>1.1.2. OpenSIPS Modules</h3></div></div></div><p>
				The following modules must be loaded before this module:
                </p><div class="itemizedlist"><ul type="disc"><li><p>
				
                            <span class="emphasis"><em>At least one NoSQL cachedb_* module</em></span>.
                        </p></li></ul></div><p>
            </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249069"></a>1.1.3. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
                </p><div class="itemizedlist"><ul type="disc"><li><p>
				
                            <span class="emphasis"><em>None</em></span>.
                        </p></li></ul></div><p>
            </p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248023"></a>1.2. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249570"></a>1.2.1. 
                <code class="varname">cachedb_url</code> (str)
            </h3></div></div></div><p>
			The URL for the CacheDB back-end to be used. It can be set more than one time. 
            </p><div class="example"><a name="id249582"></a><p class="title"><b>Example 1.1. Set
                    <code class="varname">cachedb_url</code> parameter
                </b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_cachedb","cachedb_url","mongodb:mycluster://127.0.0.1:27017/db.col")
...
                </pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249605"></a>1.3. Examples of Usage</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249610"></a>1.3.1. 
                <code class="varname">Distributed Subscriber Base</code>
            </h3></div></div></div><p>
				In order to achieve such a setup, one would have to  set the db_url parameter of the auth_db module to point to the DB_CACHEDB URL.
            </p><div class="example"><a name="id249624"></a><p class="title"><b>Example 1.2. OpenSIPS CFG Snippet for using DB_CACHEDB
                </b></p><div class="example-contents"><pre class="programlisting">
loadmodule "auth_db.so"
modparam("auth_db", "load_credentials", "$avp(user_rpid)=rpid")

loadmodule "db_cachedb.so"
loadmodule "cachedb_mongodb.so"
...
modparam("db_cachedb","cachedb_url","mongodb:mycluster://127.0.0.1:27017/my_db.col")
modparam("auth_db","db_url","cachedb://mongodb:mycluster")
...
                </pre></div></div><br class="example-break"><p>
				With such a setup, the auth_db module will load the subscribers from the MongoDB cluster, in the 'my_db' database, in the 'subscriber' collection.
            </p><p>
				The same mechanism/setup can be used to run other modules ( like usrloc, dialog, permissions, drouting, etc ) on top of a cachedb cluster.
            </p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249650"></a>1.4. Current Limitations</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249655"></a>1.4.1. 
                <code class="varname">CacheDB modules integration</code>
            </h3></div></div></div><p>
				Currently the only cachedb_* module that implements this functionality is the cachedb_mongodb module, so currently you can only emulate SQL queries to a MongoDB instance/cluster.

				There are plans to also extend this functionality to other cachedb_* backends, like Cassandra and CouchBase.
            </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249671"></a>1.4.2. 
                <code class="varname">Extensive Testing Needed</code>
            </h3></div></div></div><p>
				Since there are many OpenSIPS modules that currently use the DB interface, it wasn't feasible to test all scenarios with all modules, and there still might be some incompatibilities.  

				The module was tested with some regularily used modules ( like usrloc, dialog, permissions, drouting ), but more testing is very much welcome, and feedback is appreciated.
            </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249688"></a>1.4.3. 
                <code class="varname">CacheDB Specific 'schema' and other incompatibilities</code>
            </h3></div></div></div><p>
				Since the NoSQL backends do not usually have a strict schema involved,
				we do not provide scripts for creating such schemas, since the insertion ops will trigger the dynamically creation of the schema and info.

				Still, a specific data collection needs to be present, and that is the equivalent of the 'version' table from the SQL. Since most modules check the version table at the module setup, it's the user's responsability to setup such a 'version' collection in the respective NoSQL back-end.

				For example, for the MongoDB cluster, 'version' is a reserved keyword, so one would have to change the default version table that OpenSIPS uses ( via the 'db_version_table' global parameter ) and then manually insert the version number with something like db.my_version_table.insert({table_version : NumberInt(5), table_name : "address"})
            </p></div></div></div></div></body></html>
