<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>event_datagram Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284029"></a>event_datagram Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Razvan</span> <span class="surname">Crainea</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Razvan</span> <span class="surname">Crainea</span></h3></div></div></div><div><p class="copyright">Copyright © 2011 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id273368">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id276006">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id284068">1.2. DATAGRAM events syntax</a></span></dt><dt><span class="section"><a href="#id248012">1.3. DATAGRAM socket syntax</a></span></dt><dt><span class="section"><a href="#id249570">1.4. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249576">1.4.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249600">1.4.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249626">1.5. Exported Parameters</a></span></dt><dt><span class="section"><a href="#id249636">1.6. Exported Functions</a></span></dt><dt><span class="section"><a href="#id249646">1.7. Example</a></span></dt></dl></dd><dt><span class="chapter"><a href="#id248422">2. Frequently Asked Questions</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249656">E_PIKE_BLOCKED event</a></dt><dt>1.2. <a href="#id249672">UNIX socket</a></dt><dt>1.3. <a href="#id249684">UDP socket</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id273368"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id276006"></a>1.1. Overview</h2></div></div></div><p>
		This is a module which provides a UNIX/UDP SOCKET transport layer 
		implementation for the Event Interface. 
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284068"></a>1.2. DATAGRAM events syntax</h2></div></div></div><p>
		The raised events will follow the following grammar:
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>
			event = event_name (argument '\n')*
			</em></span></p></li><li><p><span class="emphasis"><em>
			event_name = non-quoted_string'\n'
			</em></span></p></li><li><p><span class="emphasis"><em>
			argument = ((arg_name '::')? arg_value)? | (arg_value)
			</em></span></p></li><li><p><span class="emphasis"><em>
			arg_name = not-quoted_string
			</em></span></p></li><li><p><span class="emphasis"><em>
			arg_value = not-quoted_string | '"' string '"'
			</em></span></p></li><li><p><span class="emphasis"><em>
			not-quoted_string = string - {',",\n,\r}
			</em></span></p></li></ul></div><p>
	</p><p>The event name can contain any non-quoted string character, but
		it is recommended to follow the syntax:
		E_<span class="emphasis"><em>MODULE_NAME</em></span>_<span class="emphasis"><em>EXTRA_NAME</em></span>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248012"></a>1.3. DATAGRAM socket syntax</h2></div></div></div><p>
		There are two types of sockets used by this module, based on the
		sockets type. An UNIX socket should follow this syntax:
		</p><p><span class="emphasis"><em>['unix:'] unix_socket_path</em></span></p><p>
	</p><p>
		An UDP socket should follow this syntax:
		</p><p><span class="emphasis"><em>'udp:' address ':' port</em></span></p><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249570"></a>1.4. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249576"></a>1.4.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249600"></a>1.4.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>none</em></span>
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249626"></a>1.5. Exported Parameters</h2></div></div></div><p>
		No parameter exported by this module.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249636"></a>1.6. Exported Functions</h2></div></div></div><p>
		No function exported to be used from configuration file.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249646"></a>1.7. Example</h2></div></div></div><p>
			This is an example of an event raised by the pike module
			when it decides an ip should be blocked:
		</p><div class="example"><a name="id249656"></a><p class="title"><b>Example 1.1. E_PIKE_BLOCKED event</b></p><div class="example-contents"><pre class="programlisting">

E_PIKE_BLOCKED
ip::192.168.2.11

</pre></div></div><br class="example-break"><div class="example"><a name="id249672"></a><p class="title"><b>Example 1.2. UNIX socket</b></p><div class="example-contents"><pre class="programlisting">

unix:/tmp/opensips_event.sock

</pre></div></div><br class="example-break"><div class="example"><a name="id249684"></a><p class="title"><b>Example 1.3. UDP socket</b></p><div class="example-contents"><pre class="programlisting">

udp:127.0.0.1:8081

</pre></div></div><br class="example-break"></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id248422"></a>Chapter 2. Frequently Asked Questions</h2></div></div></div><div class="qandaset"><table border="0" summary="Q and A Set"><col align="left" width="1%"><tbody><tr class="question"><td align="left" valign="top"><a name="id248441"></a><a name="id248443"></a><p><b>2.1.</b></p></td><td align="left" valign="top"><p>
				Both UNIX and UDP type of socket can be
				used to notify the events?
			</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
				Yes, you can use the both types.
			</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id248386"></a><a name="id248388"></a><p><b>2.2.</b></p></td><td align="left" valign="top"><p>What is the maximum lenght of a datagram event?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			The maximum length of a datagram event is 65457 bytes.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id248402"></a><a name="id248404"></a><p><b>2.3.</b></p></td><td align="left" valign="top"><p>Where can I find more about OpenSIPS?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Take a look at <a class="ulink" href="http://www.opensips.org/" target="_top">http://www.opensips.org/</a>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id293708"></a><a name="id293710"></a><p><b>2.4.</b></p></td><td align="left" valign="top"><p>Where can I post a question about this module?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			First at all check if your question was already answered on one of
			our mailing lists: 
		</p><div class="itemizedlist"><ul type="disc"><li><p>User Mailing List - <a class="ulink" href="http://lists.opensips.org/cgi-bin/mailman/listinfo/users" target="_top">http://lists.opensips.org/cgi-bin/mailman/listinfo/users</a></p></li><li><p>Developer Mailing List - <a class="ulink" href="http://lists.opensips.org/cgi-bin/mailman/listinfo/devel" target="_top">http://lists.opensips.org/cgi-bin/mailman/listinfo/devel</a></p></li></ul></div><p>
			E-mails regarding any stable OpenSIPS release should be sent to 
			<code class="email">&lt;<a class="email" href="mailto:users@lists.opensips.org">users@lists.opensips.org</a>&gt;</code> and e-mails regarding development versions
			should be sent to <code class="email">&lt;<a class="email" href="mailto:devel@lists.opensips.org">devel@lists.opensips.org</a>&gt;</code>.
		</p><p>
			If you want to keep the mail private, send it to 
			<code class="email">&lt;<a class="email" href="mailto:users@lists.opensips.org">users@lists.opensips.org</a>&gt;</code>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id293731"></a><a name="id293773"></a><p><b>2.5.</b></p></td><td align="left" valign="top"><p>How can I report a bug?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Please follow the guidelines provided at:
			<a class="ulink" href="https://github.com/OpenSIPS/opensips/issues" target="_top">https://github.com/OpenSIPS/opensips/issues</a>.
		</p></td></tr></tbody></table></div></div></div></body></html>
