<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>path Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id249240"></a>path Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Andreas</span> <span class="surname">Granig</span></h3><div class="affiliation"><span class="orgname">Inode GmbH<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Andreas</span> <span class="surname">Granig</span></h3></div></div></div><div><p class="copyright">Copyright © 2006 Inode GmbH</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id275653">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id249278">1.1. Overview</a></span></dt><dd><dl><dt><span class="section"><a href="#id249296">1.1.1. Path insertion for registrations</a></span></dt><dt><span class="section"><a href="#id248338">1.1.2. Outbound routing to NAT'ed UACs</a></span></dt></dl></dd><dt><span class="section"><a href="#id248364">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248370">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248394">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248421">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248426">1.3.1. <code class="varname">use_received</code> (int)</a></span></dt><dt><span class="section"><a href="#id293402">1.3.2. <code class="varname">enable_double_path</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293438">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293444">1.4.1. 
		<code class="function">add_path()</code>
		</a></span></dt><dt><span class="section"><a href="#id293484">1.4.2. 
		<code class="function">add_path(user)</code>
		</a></span></dt><dt><span class="section"><a href="#id293538">1.4.3. 
		<code class="function">add_path_received()</code>
		</a></span></dt><dt><span class="section"><a href="#id293578">1.4.4. 
		<code class="function">add_path_received(user)</code>
		</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248455">Set <code class="varname">use_received</code> parameter</a></dt><dt>1.2. <a href="#id293421">Set <code class="varname">enable_double_path</code> parameter</a></dt><dt>1.3. <a href="#id293467"><code class="function">add_path</code> usage</a></dt><dt>1.4. <a href="#id293520"><code class="function">add_path(user)</code> usage</a></dt><dt>1.5. <a href="#id293560"><code class="function">add_path_received()</code> usage</a></dt><dt>1.6. <a href="#id293601"><code class="function">add_path_received(user)</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id275653"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249278"></a>1.1. Overview</h2></div></div></div><p>
		This module is designed to be used at intermediate sip proxies like loadbalancers in front of
		registrars and proxies. It provides functions for inserting a Path header including a parameter for
		passing forward the received-<acronym class="acronym">URI</acronym> of a registration to the next hop. It also provides a mechanism
		for evaluating this parameter in subsequent requests and to set the destination <acronym class="acronym">URI</acronym> according to it.
		</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249296"></a>1.1.1. Path insertion for registrations</h3></div></div></div><p>
			For registrations in a scenario like &#8220;<span class="quote">[UAC] -&gt; [P1] -&gt; [REG]</span>&#8221;, 
			the "path" module can be used at the intermediate proxy P1 to insert a Path
			header into the message before forwarding it to the registrar REG. Two functions
			can be used to achieve this:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
					<span class="emphasis"><em>add_path(...)</em></span> adds a Path header in the form of
					&#8220;<span class="quote">Path: &lt;sip:1.2.3.4;lr&gt;</span>&#8221; to the message using the address
					of the outgoing interface. A port is only added if it's not the default
					port 5060.
					</p><p>
					If a username is passed to the function, it is also included in the Path
					<acronym class="acronym">URI</acronym>, like &#8220;<span class="quote">Path: &lt;sip:username@1.2.3.4;lr&gt;</span>&#8221;.
					</p></li><li><p>
					<span class="emphasis"><em>add_path_received(...)</em></span> also add a Path header in the
					same form as above, but also adds a parameter indicating the received-<acronym class="acronym">URI</acronym>
					of the message, like 
					&#8220;<span class="quote">Path: &lt;sip:1.2.3.4;received=sip:2.3.4.5:1234;lr&gt;</span>&#8221;. This
					is especially useful if the proxy does NAT detection and wants to pass
					the NAT'ed address to the registrar.
					</p><p>
					If the function is called with a username, it's included in the Path <acronym class="acronym">URI</acronym> too.
					</p></li></ul></div><p>
			</p><p>
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248338"></a>1.1.2. Outbound routing to NAT'ed UACs</h3></div></div></div><p>
			If the NAT'ed address of an UAC is passed to the registrar, the registrar routes back
			subsequent requests using the Path header of the registration as Route header of the
			current request. If the intermediate proxy had inserted a Path header including the
			&#8220;<span class="quote">received</span>&#8221; parameter during the registration, this parameter will show up
			in the Route header of the new request as well, allowing the intermediate proxy to route
			to this address instead of the one propagated in the Route <acronym class="acronym">URI</acronym> for tunneling through NAT.
			This behaviour can be activated by setting the module parameter &#8220;<span class="quote">use_received</span>&#8221;.
			</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248364"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248370"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				The "rr" module is needed for outbound routing according to the &#8220;<span class="quote">received</span>&#8221;
				parameter.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248394"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248421"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248426"></a>1.3.1. <code class="varname">use_received</code> (int)</h3></div></div></div><p>
		If set to 1, the &#8220;<span class="quote">received</span>&#8221; parameter of the first Route <acronym class="acronym">URI</acronym> is evaluated and
		used as destination-<acronym class="acronym">URI</acronym> if present.
		</p><p>
		<span class="emphasis"><em>
			Default value is 0.
		</em></span>
		</p><div class="example"><a name="id248455"></a><p class="title"><b>Example 1.1. Set <code class="varname">use_received</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("path", "use_received", 1)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293402"></a>1.3.2. <code class="varname">enable_double_path</code> (integer)</h3></div></div></div><p>
		There are some situations when the server needs to insert two 
		Path header fields instead of one. For example when using 
		two disconnected networks or doing cross-protocol forwarding from 
		UDP-&gt;TCP. This parameter enables inserting of 2
		Paths.
		</p><p>
		<span class="emphasis"><em>
			Default value is 1 (yes).
		</em></span>
		</p><div class="example"><a name="id293421"></a><p class="title"><b>Example 1.2. Set <code class="varname">enable_double_path</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("path", "enable_double_path", 0)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293438"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293444"></a>1.4.1. 
		<code class="function">add_path()</code>
		</h3></div></div></div><p>
		This function is used to insert a Path header in the form 
		&#8220;<span class="quote">Path: &lt;sip:1.2.3.4;lr&gt;</span>&#8221;, where &#8220;<span class="quote">1.2.3.4</span>&#8221; is the address
		of the outgoing interface.
		</p><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293467"></a><p class="title"><b>Example 1.3. <code class="function">add_path</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (!add_path()) {
	sl_send_reply("503", "Internal Path Error");
	...
};
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293484"></a>1.4.2. 
		<code class="function">add_path(user)</code>
		</h3></div></div></div><p>
		This function adds a Path header in the form 
		&#8220;<span class="quote">Path: &lt;sip:user@1.2.3.4;lr&gt;</span>&#8221;.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>user</em></span> - The username to be inserted as user part.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293520"></a><p class="title"><b>Example 1.4. <code class="function">add_path(user)</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (!add_path("loadbalancer")) {
	sl_send_reply("503", "Internal Path Error");
	...
};
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293538"></a>1.4.3. 
		<code class="function">add_path_received()</code>
		</h3></div></div></div><p>
		This function adds a Path header in the form 
		&#8220;<span class="quote">Path: &lt;sip:1.2.3.4;received=sip:2.3.4.5:1234;lr&gt;</span>&#8221;, setting it's own 
		outgoing address as domain-part, and the address the request has been received from as
		received-parameter.
		</p><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293560"></a><p class="title"><b>Example 1.5. <code class="function">add_path_received()</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (!add_path_received()) {
	sl_send_reply("503", "Internal Path Error");
	...
};
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293578"></a>1.4.4. 
		<code class="function">add_path_received(user)</code>
		</h3></div></div></div><p>
		This function adds a Path header in the form 
		&#8220;<span class="quote">Path: &lt;sip:user@1.2.3.4;received=sip:2.3.4.5:1234;lr&gt;</span>&#8221;, setting
		'user' as username part of address, it's own 
		outgoing address as domain-part, and the address the request has been received from as
		received-parameter.
		</p><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293601"></a><p class="title"><b>Example 1.6. <code class="function">add_path_received(user)</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (!add_path_received("inbound")) {
	sl_send_reply("503", "Internal Path Error");
	...
};
...
</pre></div></div><br class="example-break"></div></div></div></div></body></html>
